function assert(codestring) { // better than nothing...
	if( !eval(codestring) )
		print("Assertion Failure: " + codestring)
}

//========================================================================================================
// Vector

loadClass("vector")
function fEq(f1, f2) { return Math.abs(f1-f2)<0.000000001 }
function vEq(v1, v2)  { return fEq(0, vNorm(vSub(v1,v2))) }

assert(' vEq( vAdd(vec(1,2),vec(3,4)),  vec(4,6))     ')
assert(' vEq( vSub(vec(1,2),vec(3,4)),  vec(-2,-2))   ')
assert(' vEq( vRot(vec(1,0),Math.PI/2), vec(0,1))     ')
assert(' vEq( vUnit(vec(3,4)),          vec(0.6,0.8)) ')
assert(' fEq( vArg(vecP(1,0.3)),        0.3)          ')
var v = vec(2,1)
var u = vec(0,2)
var z = vProj(u,v)
assert(' fEq(  vArg(v), vArg(z))    ')
assert(' fEq(  0, vIP(z,vSub(u,z))) ')
assert(' vEq(  vProj(vec(1,2),vec(-1,0)), vec(1,0)) ')

//========================================================================================================
// Send

loadClass("send")

var s, send = create_sender({flush: function(){}, write: function(c){s+=String.fromCharCode(c)}})
assert('  s=""; send("--", "al"); s=="al;"        ')
assert('  s=""; send("--", "bL"); s=="bl;l;"      ')
assert('  s=""; send("ar", "bL"); s=="bl;bl;l;"   ')
assert('  s=""; send("bL", "aR"); s=="ar;ar;r;r;" ')
assert('  s=""; send("--", "--"); s==""           ')
assert('  s=""; send("br", "-l"); s=="al;l;"      ')
assert('  s=""; send("bl", "-R"); s=="ar;r;r;"    ')

//========================================================================================================
// Recv

loadClass("recv")

var recv = create_receiver("E 10 20 ;C 30 ;B 40 ;K 50 ;I 1 2 3 4 5 6 7 8 ;"+
  "T 1 -- 2 3 -4 5 ;T 0 -- 0 0 0 0 b 3 4 5 c 6 7 8 m 9 1 -2 3 ;")

assert('  var{tag:tag, t:t, s:s}=recv(); tag=="E" && t==10 && s==20  ')
assert('  var{tag:tag, t:t} = recv();    tag=="C" && t==30   ')
assert('  var{tag:tag, t:t} = recv();    tag=="B" && t==40   ')
assert('  var{tag:tag, t:t} = recv();    tag=="K" && t==50   ')
assert('  var{tag:tag,dx:dx,dy:dy,tl:tl,msen:msen,Msen:Msen,Mspd:Mspd,Mtrn:Mtrn,Mhtrn:Mhtrn} = recv();'+
       ' tag=="I" && dx==1 && dy==2 && tl==3 && msen==4 && Msen==5 && Mspd==6/1000 &&'+
       ' Mtrn==7*Math.PI/180/1000 && Mhtrn==8*Math.PI/180/1000 ')
assert('  var{tag:tag, t:t, vc:vc, x:x, y:y, d:d, spd:spd, objs:objs, r:r, p:p}=recv();'+
       '  tag=="T" && t==1 && vc=="--" && x==2 && y==3 && d==356*Math.PI/180 && spd==0.005 &&'+
       '  objs.length==0 && r==0.5 && p.r==0.5 && vEq(p,vec(x,y))')
assert('  var{objs:[x,y,z,n]}=recv(); !n&& x.tag=="b" && x.x==3 && x.y==4 && x.r==5 &&'+
       '   y.tag=="c" && z.tag=="m" && z.x==9 && z.y==1 && z.d==358*Math.PI/180 && z.r==0.4 && z.s==0.003')
